<template>
  <a-modal
    :title="modalTitle"
    :width="640"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @cancel="handleCancel"
  >
    <a-form :form="form">
      <a-form-item
        label="上传文件"
        :labelCol="BaseTool.Constant.labelCol"
        :wrapperCol="BaseTool.Constant.wrapperCol"
      >
        <a-upload :fileList="fileList" :remove="handleRemove" :beforeUpload="beforeUpload">
          <a-button> <a-icon type="upload" />选择上传文件</a-button>
        </a-upload>
      </a-form-item>
    </a-form>
    <template slot="footer">
      <a-button :loading="confirmLoading" type="primary" @click="save()">确定</a-button>
    </template>
  </a-modal>
</template>

<script>
import { importPurchaseDispatchOrderList } from '@/api/purchase/purchase-dispatch-order-list'

export default {
  name: 'BasePurchaseOrderListImportForm',
  data () {
    return {
      confirmLoading: false,
      modalTitle: null,
      form: this.$form.createForm(this),
      dispatchOrderId: '-1',
      visible: false,
      fileList: []
    }
  },
  methods: {
    base (dispatchOrderId) {
      this.visible = true
      this.dispatchOrderId = dispatchOrderId
      this.fileList = []
      this.modalTitle = '发运明细导入'
    },
    handleRemove (file) {
      const index = this.fileList.indexOf(file)
      const newFileList = this.fileList.slice()
      newFileList.splice(index, 1)
      this.fileList = newFileList
    },
    beforeUpload (file) {
      const reg = /\.(xls|xlsx)(\?.*)?$/
      return new Promise((resolve, reject) => {
        if (reg.test(file.name)) {
          this.fileList = [file]
          return false
        } else {
          this.$message.error(`请上传正确的excel文件`)
          reject(new Error('请上传正确的excel文件'))
          return false
        }
      })
    },
    save () {
      const { form: { validateFieldsAndScroll } } = this
      this.confirmLoading = true
      validateFieldsAndScroll((errors, values) => {
        if (errors) {
          this.confirmLoading = false
          return
        }
        const formData = new FormData()
        formData.append('file', this.fileList[0])
        formData.append('dispatchOrderId', this.dispatchOrderId)
        importPurchaseDispatchOrderList(formData)
          .then(() => {
            this.handleCancel(values)
          }).catch(() => {
            this.confirmLoading = false
          })
      })
    },
    handleCancel (values) {
      this.visible = false
      this.confirmLoading = false
      this.form.resetFields()
      this.$emit('ok', values)
    }

  }
}
</script>
